=== debian/changelog ===
zfp (1.0.0-7) unstable; urgency=medium

  * Standards version bumped to 4.6.2, no changes.
  * debian/patches:
    - new 0001-Prevent-LTO-in-libm-dependency-check.patch.
      Closes: #1030107.
  * Enable LTO optimization.
  * Update d/copyright.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 11 Feb 2023 08:49:53 +0000

zfp (1.0.0-6) unstable; urgency=medium

  * Apply patch. Thanks Graham Inggs. (Closes: #1030109)

 -- Gürkan Myczko <tar@debian.org>  Tue, 31 Jan 2023 13:44:11 +0100

zfp (1.0.0-5) unstable; urgency=medium

  * Team upload.
  * Use pybuild to compile for all Python versions (Closes: #1025196)
  * Use dh-sequences
  * Move package description to source package
  * Cleanup install files

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 02 Dec 2022 10:19:38 +0100

zfp (1.0.0-4) unstable; urgency=medium

  * Team upload acked by Gürkan Myczko.

  [ Debian Janitor ]
  * Apply multi-arch hints. + libzfp-dev: Drop Multi-Arch: same.

  [ Helmut Grohne ]
  * Don't move cmake files around. (Closes: #1025259)

 -- Helmut Grohne <helmut@subdivi.de>  Fri, 02 Dec 2022 09:38:28 +0100

zfp (1.0.0-3) unstable; urgency=medium

  * Compile with -DZFP_BIT_STREAM_WORD_SIZE=8. (Closes: #1023821)

 -- Gürkan Myczko <tar@debian.org>  Thu, 10 Nov 2022 22:27:10 +0100

zfp (1.0.0-2) unstable; urgency=medium

  * Upload to sid.
  * d/rules: set ZFP_BUILD_TESTING_SMALL to OFF.

 -- Gürkan Myczko <tar@debian.org>  Fri, 16 Sep 2022 08:28:04 +0200

zfp (1.0.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1017808)

 -- Gürkan Myczko <tar@debian.org>  Sat, 20 Aug 2022 21:51:21 +0200
