=== debian/control ===
Source: zfp
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <tar@debian.org>,
           Antonio Valentino <antonio.valentino@tiscali.it>
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 cython3,
 gfortran,
 dh-sequence-python3,
 dh-sequence-numpy3,
 libpython3-all-dev,
 dh-sequence-pkgkde-symbolshelper,
 python3-numpy,
 python3-setuptools,
 python3-all
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/zfp
Vcs-Git: https://salsa.debian.org/science-team/zfp.git
Homepage: https://zfp.llnl.gov
Description: Fixed-Rate Compressed Floating-Point Arrays
 This is a compressed format for representing multidimensional floating-point
 and integer arrays.  zfp provides compressed-array classes that support high
 throughput read and write random access to individual array elements. zfp
 also supports serial and parallel (OpenMP and CUDA) compression of whole
 arrays, e.g., for applications that read and write large data sets to and
 from disk.

Package: libzfp1
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: libzfp-dev
Architecture: any
Section: libdevel
Depends:
 ${misc:Depends},
 libzfp1 (= ${binary:Version}),
Description: ${source:Synopsis} (Development files)
 ${source:Extended-Description}
 .
 This is a development package of zfp.

Package: zfp
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: ${source:Synopsis} - binary programs
 ${source:Extended-Description}
 .
 This package contains the binary program zfp.

Package: python3-zfpy
Architecture: any
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
 libzfp1,
 python3-numpy
Description: Python 3 bindings to the ${source:Synopsis}
 ${source:Extended-Description}
 .
 This is a Python package of zfp.
