## zfp 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,6 +50,9 @@
 if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
   set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${ZFP_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
 endif()
+
+# Setup RPath
+set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
 
 #------------------------------------------------------------------------------#
 # Top level options
@@ -257,10 +260,10 @@
 
 # Link libm only if necessary
 include(CheckCSourceCompiles)
-check_c_source_compiles("#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}" HAVE_MATH)
+check_c_source_compiles("#include<math.h>\nint main(int n,char*v[]){return sqrt(n);}" HAVE_MATH)
 if(NOT HAVE_MATH)
   set(CMAKE_REQUIRED_LIBRARIES m)
-  check_c_source_compiles("#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}" HAVE_LIBM_MATH)
+  check_c_source_compiles("#include<math.h>\nint main(int n,char*v[]){return sqrt(n);}" HAVE_LIBM_MATH)
   unset(CMAKE_REQUIRED_LIBRARIES)
   if(NOT HAVE_LIBM_MATH)
     message(FATAL_ERROR "Unable to use C math library functions (with or without -lm)")
@@ -271,7 +274,7 @@
 # Add source code
 #------------------------------------------------------------------------------#
 include(CTest)
-if(BUILD_TESTING)
+if(BUILD_TESTING OR BUILD_TESTING_FULL)
   enable_testing()
 endif()
 
@@ -315,7 +318,7 @@
   add_subdirectory(examples)
 endif()
 
-if(BUILD_TESTING)
+if(BUILD_TESTING OR BUILD_TESTING_FULL)
   # Disable gtest install to prevent clobbering existing installations 
   option(INSTALL_GMOCK "Install Googlemock" OFF)
   option(INSTALL_GTEST "Install Googletest" OFF)
@@ -339,5 +342,3 @@
   set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE Release)
 endif()
 
-#------------------------------------------------------------------------------#
-# Packaging
