=== debian/changelog ===
zfp (1.0.1-4deepin1) unstable; urgency=medium

  * revert 64-bit time_t transition patch.

 -- lichenggang <lichenggang@deepin.org>  Fri, 18 Oct 2024 18:12:31 +0800

zfp (1.0.1-4) unstable; urgency=medium

  * Ack NMU.
  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Tue, 18 Jun 2024 13:07:28 +0000

zfp (1.0.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063310

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 08:45:44 +0000

zfp (1.0.1-3) unstable; urgency=medium

  * debian/rules:
    - Revert the changes in the BIT_STREAM_WORD_TYPE configuration
      implemneted with the upload of the upstream version 1.0.1 and
      skip the failing tests (Closes: #1060807).
      According to https://github.com/LLNL/zfp/issues/51, test failures
      in ZFP uni tests are gue to limitations of the test suite implementation
      not supporting all possible configurations.
      On the other hand some of the packages that depend on ZFP, like, e.g.,
      h5z-fzp mandatorily require the old configuration.
  * debian/patches:
    - New 0002-Skip-broken-tests.patch (see comments above).
  * Update d/copyright.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Wed, 17 Jan 2024 08:08:28 +0000

zfp (1.0.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Wed, 27 Dec 2023 07:58:26 +0000

zfp (1.0.1-1) experimental; urgency=medium

  * New upstream release.
  * Update d/copyright.
  * debian/patches:
    - Drop 0001-Prevent-LTO-in-libm-dependency-check.patch, applied upstream.
    - New 0001-Do-not-set-RPATH-RUNPATH.patch.
  * Add salsa CI configuration file.
  * debian/rules:
    - Disable tests on non 64bit architectures
      (see https://github.com/LLNL/zfp/issues/51).
  * Update symbol file for amd64.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Tue, 26 Dec 2023 17:51:14 +0000

zfp (1.0.0-8) unstable; urgency=medium

  * Switch to autopkgtest-pkg-pybuild.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 09 Dec 2023 15:47:40 +0000
